/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006      by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2005-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: prc_config.h 1157 2008-06-26 03:10:08Z ertl-yutaka $
 */

/*
 *              ץå¸⥸塼M32Rѡ
 *
 *  Υ󥯥롼ɥեϡtarget_config.hʤޤϡ饤
 *  롼ɤեˤΤߤ饤󥯥롼ɤ롥¾Υե뤫
 *  ľܥ󥯥롼ɤƤϤʤʤ
 */

#ifndef TOPPERS_PRC_CONFIG_H
#define TOPPERS_PRC_CONFIG_H

/*
 *  ץå¸
 */
#include "m32r.h"

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ץåü̿Υ饤ؿ
 */
#include "prc_insn.h"

/*
 *  󥿥ƥѤΥå
 */
#define TOPPERS_ISTKPT(istk, istksz) ((STK_T *)((char_t *)(istk) + (istksz)))

/*
 *  ƥȥ֥å
 */
typedef struct task_context_block {
	void    *sp;            /* åݥ */
	FP      pc;             /* ץ५ */
} CTXB;

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ͥ٥ޥ饤֥
 *
 *  M32RǤϡߥȥγߥޥ쥸ICUIMASKˤ13 
 *  ӥåܤ15ӥåܤ3ӥåȤǳͥ٥ޥݻ롥
 *  ߥޥ0ʺǹ͡ޥ֥߶ػߡˤ7ʺ͡٥
 *  0!+6 ߼ղǽˤͤġ
 */

/*
 *  ͥ٥ޥγɽɽѴ
 */
#define EXT_IPM(iipm)   (CAST(PRI, (iipm) - 7))        /* ɽѴ */
#define INT_IPM(ipm)    (CAST(uint8_t, (ipm) + 7))     /* ɽѴ */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  IPMʥϡɥγͥ٥ޥɽˤθͤɽФ
 */
Inline uint8_t
current_iipm(void)
{
	return (sil_reb_mem((void*)(ICUIMASK+1)));      
}

/*
 *  IPMʥϡɥγͥ٥ޥɽˤθͤ
 */
Inline void
set_iipm(uint8_t iipm)
{       
	/* 
	 *  M32RǤϡICUIMASKݤˤϡ߶ػ߾֤ˤʤ
	 *  ʤʤ
	 */
	SIL_PRE_LOC;

	SIL_LOC_INT();
	sil_wrb_mem((void*)(ICUIMASK+1), iipm);
# if 0 /* ICUISTSISNӥåȥꥢɤΥߡ */
	current_iipm();
	current_iipm();
#endif 
	SIL_UNL_INT();
}

/*
 *  TOPPERSɸ߽ǥμ¸
 *
 *  M32Rϡߥȥ˳ߥޥ쥸ICUIMASKˤ
 *  Ƥ뤬CPUåե饰뵡ǽʤΤᡤCPU
 *  ե饰εǽIPMˤäƼ¸롥
 *
 *  ޤCPUåե饰͡ʤʤCPUå֡ˤϡΤ
 *  lock_flagˤѰդݻ롥
 *
 *  CPUåե饰ꥢƤ֡ʤʤCPUå֤
 *  ֡ˤϡIPMʥϡɥγͥ٥ޥˤ򡤥ǥγ
 *  ͥ٥ޥͤꤹ롥δ֤ϡǥγͥ٥ޥ
 *  ϡIPMѤݻ롥
 *
 *  ФCPUåե饰åȤƤ֡ʤʤCPU
 *  ֤δ֡ˤϡIPMʥϡɥγͥ٥ޥˤ򡤥ͥ
 *  γߤ򤹤٤ƥޥ͡TIPM_LOCKˤȡǥγͥ
 *  ٥ޥȤι⤤ꤹ롥δ֤Υǥγͥ٥ޥ
 *  ϡΤѿsaved_iipmɽݻˤѰդݻ
 *  롥
 */

/*
 *  ƥȤλ
 *
 *  M32RǤϡƥȤ桼åǡ󥿥ƥ
 *  ȤߥåǼ¹Ԥ롥ѤƤ륹åϡץå
 *  ָ쥸PSWˤΥå⡼ɡSM˥ӥåȤˤȽ̤롥
 *  ƥȤtrueƥȤfalse֤
 */
Inline bool_t
sense_context(void)
{
	return ((current_psw() & 0x80) == 0U);
}

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  CPUå֤Ǥγͥ٥ޥ
 *
 *  TIPM_LOCKϡͥγߤ򤹤٤ƥޥͤ롥
 *
 *  M32RǤϡTMIN_INTPRI0ꤹȡΥޥ֥ߡʥ
 *  ֥졼SBI˰ʳ˥ͥγߤߤʤȤˤ
 *  롥
 */
#define TIPM_LOCK               TMIN_INTPRI

/*
 *  CPUå֤Ǥγͥ٥ޥɽ
 */
#define IIPM_LOCK               INT_IPM(TIPM_LOCK)

/*
 *  TIPM_ENAALLʳͥ٥ޥˤɽ
 */
#define IIPM_ENAALL             (INT_IPM(TIPM_ENAALL))

#ifndef TOPPERS_MACRO_ONLY

/*
 *  CPUåե饰¸Τѿ
 *
 *  ѿϡCPUå֤λΤ߽񤭴Ƥ褤ΤȤ롥
 */
extern volatile bool_t     lock_flag; /* CPUåե饰ͤݻѿ */
extern volatile uint8_t    saved_iipm;/* ͥ٥ޥ¸ѿ */

/*
 *  CPUå֤ؤΰܹ
 *
 *  IPMʥϡɥγͥ٥ޥˤsaved_iipm¸
 *  ͥγߤ٤ƥޥ͡TIPM_LOCKˤꤹ롥ޤ
 *  lock_flagtrueˤ롥
 *
 *  IPMǽ餫TIPM_LOCKƱ⤤ˤϡ
 *  saved_iipm¸ΤߤǡTIPM_LOCKˤꤷʤϡǥ
 *  γͥ٥ޥTIPM_LOCKƱ⤤٥
 *  Ƥ֤ˤ롥
 *
 *  δؿϡCPUå֡lock_flagtrueξ֡ˤǸƤФ뤳Ȥ
 *  ʤΤꤷƤ롥
 */
Inline void
x_lock_cpu(void)
{
	uint8_t iipm;

    /*
     *  current_iipm()֤ͤľsaved_iipm¸ѿiipm 
     *  ѤƤΤϡcurrent_iipm()Ƥľ˳ߤȯ
     *  ư줿߽saved_iipmѹǽ뤿
     *  롥
     */
    iipm = current_iipm();
	if (IIPM_LOCK < iipm) {
		set_iipm(IIPM_LOCK);
	}
    saved_iipm = iipm;    
    lock_flag = true;
	Asm("":::"memory");
}

#define t_lock_cpu()    x_lock_cpu()
#define i_lock_cpu()    x_lock_cpu()

/*
 *  CPUå֤β
 *
 *  lock_flagfalseˤIPMʥϡɥγͥ٥ޥˤ
 *  saved_iipm¸᤹ͤ
 *
 *  δؿϡCPUå֡lock_flagtrueξ֡ˤǤΤ߸ƤФ
 *  ΤꤷƤ롥
 */
Inline void
x_unlock_cpu(void)
{
	Asm("":::"memory");
	lock_flag = false;
	set_iipm(saved_iipm);
}

#define t_unlock_cpu()  x_unlock_cpu()
#define i_unlock_cpu()  x_unlock_cpu()

/*
 *  CPUå֤λ
 */
Inline bool_t
x_sense_lock(void)
{
	return(lock_flag);
}

#define t_sense_lock()  x_sense_lock()
#define i_sense_lock()  x_sense_lock()

/*
 *  chg_ipmͭʳͥ٤ϰϤȽ
 *
 *  TMIN_INTPRIͤˤ餺chg_ipmǤϡ-7TIPM_ENAALLʡ0ˤϰ
 *  Ǥ뤳ȤȤʥåγĥˡ
 */
#define VALID_INTPRI_CHGIPM(intpri) \
                                ((-7 <= (intpri) && (intpri) <= TIPM_ENAALL))

/*
 * ʥǥΡ˳ͥ٥ޥ
 *
 *  CPUåե饰ꥢƤϡϡɥγͥ٥
 *  ꤹ롥CPUåե饰åȤƤϡsaved_iipm
 *  ꤷˡϡɥγͥ٥ޥꤷ褦
 *  ʥǥΡ˳ͥ٥ޥTIPM_LOCKι⤤ꤹ롥
 */
Inline void
x_set_ipm(PRI intpri)
{
    uint8_t   iipm = INT_IPM(intpri);

    if (!lock_flag) {
        set_iipm(iipm);
    }
    else {
        saved_iipm = iipm;
        set_iipm(iipm <= IIPM_LOCK ? iipm : IIPM_LOCK);
    }
}

#define t_set_ipm(intpri)       x_set_ipm(intpri)
#define i_set_ipm(intpri)       x_set_ipm(intpri)

/*
 * ʥǥΡ˳ͥ٥ޥλ
 *
 *  CPUåե饰ꥢƤϥϡɥγͥ٥
 *  򡤥åȤƤsaved_iipm򻲾Ȥ롥
 */
Inline PRI
x_get_ipm(void)
{
	uint8_t iipm;

    if (!lock_flag) {
        iipm = current_iipm();
    }
    else {
        iipm = saved_iipm;
    }
    return(EXT_IPM(iipm));
}

#define t_get_ipm()     x_get_ipm()
#define i_get_ipm()     x_get_ipm()

/*
 *  ǹ̥ͥؤΥǥѥåprc_support.S
 *
 *  dispatchϡƥȤƤӽФ줿ӥ
 *  ƤӽФ٤ΤǡƥȡCPUå֡ǥѥ
 *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
 *  Фʤʤ
 */
extern void     dispatch(void);

/*
 *  ǥѥåưϡprc_support.S
 *
 *  start_dispatchϡͥ뵯ư˸ƤӽФ٤Τǡ٤Ƥγ
 *  ߤػߤ֡ʳߥå֤Ʊξ֡ˤǸƤӽФʤ
 *  ʤʤ
 */
extern void     start_dispatch(void) NoReturn;

/*
 *  ߤΥƥȤΤƤƥǥѥåprc_support.S
 *
 *  exit_and_dispatchϡext_tskƤӽФ٤Τǡƥ
 *  ȡCPUå֡ǥѥåľ֡ʥǥΡ˳ͥ
 *  ٥ޥ֤ǸƤӽФʤФʤʤ
 */
extern void     exit_and_dispatch(void) NoReturn;

/*
 *  ͥνλθƽФprc_support.S
 *
 *  call_exit_kernelϡͥνλ˸ƤӽФ٤Τǡ󥿥
 *  ƥȤڤ괹ơͥνλexit_kernelˤƤӽ
 *  
 */
extern void     call_exit_kernel(void) NoReturn;

/*
 *  ƥȤν
 *
 *  ٻ߾֤¹ԤǤ֤˰ܹԤ˸ƤФ롥λ
 *  ǥåΰȤäƤϤʤʤ
 *
 *  activate_context򡤥饤ؿǤϤʤޥȤƤΤϡ
 *  λǤTCBƤʤǤ롥
 */
extern void     start_r(void);

#define activate_context(p_tcb)                                        \
{                                                                      \
	(p_tcb)->tskctxb.sp  = (void *)((char *)((p_tcb)->p_tinib->stk)	   \
									+ (p_tcb)->p_tinib->stksz);		   \
	(p_tcb)->tskctxb.pc  = (void *) start_r;						   \
}

/*
 *  calltexϻѤ
 */
/* #define OMIT_CALLTEX */

/*
 *  ߥϥɥֹCPU㳰ϥɥֹϰϤȽ
 *
 *  M32102ǤϡINT0üҳߡ1ˤSIO4ߡ57ˤޤǤͭ
 *  ϰϤǤ롥M32R-IIǤϡ1SIO1ߡ51ˤޤǤͭϰϤ
 *  롥ξǤ⡤ͽװ뤿ᡤʬͭ
 *  ϤʤȽǤɬפ롥
 */
#define VALID_INHNO_DEFINH(inhno)               (TMIN_INHNO <= (inhno) && (inhno) <= TMAX_INHNO)
#define VALID_EXCNO_DEFEXC(excno)               (TMIN_EXCNO <= (excno) && (excno) <= TMAX_EXCNO) 

/*
 *  ߥϥɥơ֥
 *
 *  ߥϥɥεưϤǼơ֥롥ߥϥɥơ֥
 *  Τϥե졼Ū롥
 */

extern const FP inh_tbl[TNUM_INH];

/*
 *  CPU㳰ϥɥơ֥
 */
extern const FP exch_tbl[TNUM_EXC];

/*
 *  ߥϥɥ
 */
Inline void
x_define_inh(INHNO inhno, FP inthdr)
{
}

/*
 *  CPU㳰ϥɥ
 */
Inline void
x_define_exc(EXCNO excno, FP exchdr)
{
}

/*
 *  ߥϥɥޥ
 */
#define INT_ENTRY(inhno, inthdr)        inthdr
#define INTHDR_ENTRY(inhno, inhno_num, inthdr)  extern void inthdr(void);

/*
 *  CPU㳰ϥɥޥ
 *
 *  CPU㳰ϥɥϡ󥿥ƥȤǼ¹Ԥ롥ΤᡤCPU
 *  ϥɥƤӽФ˳ߥ⡼ɤ˰ܹԤ꥿󤷤Ƥ
 *  Υ⡼ɤ᤹Υ⡼ɤ᤹ˡߥ⡼ɤ˰ܹԤ
 *  SRߥå¸ʥ꥿SR򻲾Ȥ⤢
 *  å¸礬ꡤȤΤݡˡ
 */
#define EXC_ENTRY(excno, exchdr)        exchdr
#define EXCHDR_ENTRY(excno, excno_num, exchdr)  extern void exchdr(void *p_excinf);

/*
 *  CPU㳰ȯIPMʥϡɥγͥ٥ޥɽ
 *  ˤλȡexception_handlerprc_support.Sˤ򤷤ߥޥ
 *  쥸͡ICUIMASKˤξ16ӥåȤФ
 */
Inline uint32_t
exc_get_iipm(void *p_excinf)
{
	return (((uint32_t *)p_excinf)[0] >> 16);
}

/*
 *  CPU㳰ȯΥƥȤλ
 *
 *  CPU㳰ȯΥƥȤƥȤξ
 *  false󥿥ƥȤξtrue֤M32RǤp_excinf
 *  CPU㳰ȯspͤǼƤ롥exception_handler 
 *  prc_support.Sˤǥå򤷤pswФƥȤ
 *  pswbpswեɤbsmͤȽꤹ롥bsm0ξϳߥå
 *  ʤΤ󥿥ƥȡtrueˡ1 ξϥ桼åʤΤ
 *  ƥȡfalseˤȽǤ롥
 */
Inline bool_t
exc_sense_context(void *p_excinf)
{
	return ((((uint32_t *)p_excinf)[1] & 0x8000) == 0);
}

/*
 *  CPU㳰ȯCPUå֤λ
 *
 *  CPUå֤λtrue֤
 */
Inline bool_t
exc_sense_cpulock(void *p_excinf)
{
	return (exc_get_iipm(p_excinf) == IIPM_LOCK);   
}

/*
 *  CPU㳰ȯγߥå֤λ
 *
 *  ߥå֤λtrue֤
 */
Inline bool_t
exc_sense_intlock(void *p_excinf)
{
	return ((((uint32_t *)p_excinf)[1] & 0x4000) == 0);     
}

/*
 *  CPU㳰ȯΥƥȤȳߤΥޥ֤λ
 *
 *  CPU㳰ȯΥƥ֤ͥ¹Ǥʤ
 *  ƥȤǤꡤߥå֤ǤʤCPUå֤Ǥʤʥ
 *  ǥΡ˳ͥ٥ޥ֤ǤtrueǤʤ
 *  false֤CPU㳰ͥγ߽ȯ
 *  ˤfalse֤ˡ
 *
 *  M32RǤϡ㳰ȯΥƥȡ㳰ȯγߥåե饰
 *  bpswIEӥåȡˡ㳰ȯγߥޥ򤽤줾å롥
 */
Inline bool_t
exc_sense_intmask(void *p_excinf)
{
	return ( !exc_sense_context(p_excinf) && 
			 !exc_sense_intlock(p_excinf) && 
			 (exc_get_iipm(p_excinf) == IIPM_ENAALL));
}

/*
 *  CPU㳰ȯΥƥȤȳߡCPUå֤λ
 *
 *  CPU㳰ȯΥƥ֤ͥ¹Ǥʤ
 *  ƥȤǤꡤߥå֤ǤʤCPUå֤Ǥʤ
 *  trueǤʤfalse֤CPU㳰ͥγ߽
 *  ȯˤfalse֤ˡ
 */
Inline bool_t
exc_sense_unlock(void *p_excinf)
{
	return (!exc_sense_context(p_excinf) && 
			!exc_sense_intlock(p_excinf) && 
			!exc_sense_cpulock(p_excinf));  
}

/*
 *  ̤Ͽγߤȯ˸ƤӽФ
 */
extern void default_int_handler(void *p_excinf);

/*
 *  ϿƤʤ㳰ȯȸƤӽФ
 */
extern void default_exc_handler(void *p_excinf);

/*
 *  ץå¸ν
 */
extern void     prc_initialize(void);

/*
 *  ץå¸νλ
 */
extern void     prc_terminate(void);

/*
 *  ֹϰϤȽ
 */
#define VALID_INTNO(intno) (TMIN_INTNO <= (intno) && (intno) <= TMAX_INTNO)
#define VALID_INTNO_DISINT(intno)    VALID_INTNO(intno)
#define VALID_INTNO_CFGINT(intno)    VALID_INTNO(intno)

/*
 *  ׵ػߥե饰Υå
 *
 *  쥸γ׵յĥӥåȡIENˤ0ꤷ
 *  ׵դػߤ롥°ꤵƤʤ׵饤
 *  ФƳ׵ػߥե饰򥻥åȤ褦Ȥˤϡfalse
 *  ֤
 */
Inline bool_t
x_disable_int(INTNO intno)
{
    uint32_t ctlr = IRC_CTL_BASE + intno * 4;
    uint8_t req_flag = sil_reb_mem((void*)(ctlr+2));
        
    /* 
     *  IENӥåȤ0ˤ롥
     */
	req_flag &= ~(0x10);
	sil_wrb_mem((void*)(ctlr+2), req_flag );
	return(true);
}

#define t_disable_int(intno) x_disable_int(intno)
#define i_disable_int(intno) x_disable_int(intno)

/*
 *  ׵ػߥե饰β
 *
 *  쥸γ׵յĥӥåȡIENˤ1ꤷ
 *  ׵յĤȤʤ롥°ꤵƤʤ׵饤
 *  ФƳ׵ػߥե饰򥯥ꥢ褦Ȥˤϡfalse
 *  ֤
 */
Inline bool_t
x_enable_int(INTNO intno)
{
    uint32_t ctlr = IRC_CTL_BASE + intno * 4;
    uint8_t req_flag = sil_reb_mem((void*)ctlr+2);
        
    /* 
     *  IENӥåȤ1ˤ롥
     */
	req_flag |= 0x10;
	sil_wrb_mem((void*)(ctlr+2), req_flag );
	return(true);
}

#define t_enable_int(intno) x_enable_int(intno)
#define i_enable_int(intno) x_enable_int(intno)

/*
 *  ׵饤°
 *
 *  M32RǤϡͥǰͥ٤7ʳǤ뤿ᡤintpri 
 *  Ϳ뤳ȤǤͤ-7-1ɸǤ롥
 */
extern void    x_config_int(INTNO intno, ATR intatr, PRI intpri);

/*
 *  ׵Υꥢ
 */
Inline void
x_clear_int(INTNO intno)
{
    uint32_t ctlr = IRC_CTL_BASE + intno * 4;
    uint8_t req_flag = sil_reb_mem((void*)(ctlr+2));

    /* 
     *  IREQӥåȤ1񤭹
     */
	req_flag |= 0x01;
	sil_wrb_mem((void*)(ctlr+2), req_flag );
}

#define t_clear_int(intno)              x_clear_int(intno)
#define i_clear_int(intno)              x_clear_int(intno)

/*
 *  ׵Υå
 */
Inline bool_t
x_probe_int(INTNO intno)
{
	return ((sil_reb_mem((void*)(IRC_CTL_BASE + intno * 4 + 2)) & 0x01) != 0);
}

#define t_probe_int(intno)              x_probe_int(intno)
#define i_probe_int(intno)              x_probe_int(intno)

/*
 *  ߥϥɥɬפIRC
 *
 *  M32RǤϡߥơ쥸ɹߤˤꡤ׵ϥ
 *  ΤǡɬפʽϤʤ
 */
Inline void
i_begin_int(INTNO intno)
{
}

/*
 *  ߥϥɥνиɬפIRC
 */
Inline void
i_end_int(INTNO intno)
{
}

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_PRC_CONFIG_H */
