/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006      by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: target_serial.c 8 2006-10-29 12:01:12Z asp $
 */

/*
 *  ꥢI/OǥХSIO˥ɥ饤СOAKS32Rѡ
 */

#include <kernel.h>
#include <sil.h>
#include "target_serial.h"
#include "target_syssvc.h"

/*
 *  쥸
 */
#define SIO_TYP_M32RUART	0x00000001
#define SIO_STS_SENDING		0x80000000

#define SIO_TYP(x)			((x) & 0x000000ff)
#define ID_PORT(x)			((x) + 1)
#define INDEX_PORT(x)		((x) - 1)
#define GET_SIOPCB(x)		(&siopcb_table[INDEX_PORT(x)])

/*
 *  ꥢI/Oݡȴ֥åΥꥢ
 */
SIOPCB siopcb_table[TNUM_PORT];

/*
 *  SIOɥ饤Фν
 */
void
sio_initialize(intptr_t exinf)
{
	int_t i;
	
	for (i=0; i<TNUM_PORT; i++) {
		siopcb_table[i].flags = SIO_TYP_M32RUART;
		siopcb_table[i].port = i;
		siopcb_table[i].exinf = 0;
	}
}

/*
 *  ꥢI/OݡȤΥץ
 */
SIOPCB *
sio_opn_por(ID siopid, intptr_t exinf)
{
	SIOPCB * siopcb = GET_SIOPCB(siopid);

	/* ĥγǼ */
	siopcb->exinf = exinf;

	switch (SIO_TYP(siopcb->flags)) {
	case SIO_TYP_M32RUART:
		/* UART */
		sil_wrb_mem((void *)(SIOCR(siopcb->port)+3), 0);

		/* ݡȤ򳫤(UART0) */
		sil_wrb_mem((void *)PDATA(5), 0);
		sil_wrb_mem((void *)PDIR(5), 0x80);

		/* UART⡼ */
		sil_wrb_mem((void *)(SIOMOD0(siopcb->port)+3), 0);
		sil_wrh_mem((void *)(SIOMOD1(siopcb->port)+2), 0x0800);

		/* ܡ졼 */
		sil_wrh_mem((void *)(SIOBAUR(siopcb->port)+2), SERIAL_CLKDIV);
		sil_wrb_mem((void *)(SIORBAUR(siopcb->port)+3), SERIAL_CLKCMP);

		/* ȯ */
		sil_wrh_mem((void *)(SIOTRCR(siopcb->port)+2), 0x0006);
		
		/* ơꥢ, ư */
		sil_wrb_mem((void *)(SIOCR(siopcb->port)+2), 0x3);
		sil_wrb_mem((void *)(SIOCR(siopcb->port)+3), 0x3);
		
		/* ׵յ */
		sil_wrh_mem((void *)(ICUCR(SIO,siopcb->port)+2), 0x1000);
		sil_wrh_mem((void *)(ICUCR(SIO,siopcb->port)+6), 0x1000);

		/* TxD,RxDԥͭ(UART0) */
		sil_wrh_mem((void *)PMOD(5), 0x5500);
		break;
	}

	return siopcb;
}

/*
 *  ꥢI/OݡȤΥ
 */
void
sio_cls_por(SIOPCB *p_siopcb)
{
	switch (SIO_TYP(p_siopcb->flags)) {
	case SIO_TYP_M32RUART:
		/* ưػߤ */
		sil_wrb_mem((void *)(SIOCR(p_siopcb->port)+3), 0);
		break;
	}
}

inline bool_t
hw_port_getready(SIOPCB *p)
{
	switch (SIO_TYP(p->flags)) {
	case SIO_TYP_M32RUART:
		return ((sil_reb_mem((void *)(SIOSTS(p->port)+3)) & 0x4) != 0 ? true : false);
	}
	return false;
}

/*
 *  SIOߥϥɥ
 */
void sio_rx_handler(intptr_t exinf)
{
	int_t port;
	
	for (port=0; port<TNUM_PORT; ++port) {
		if (hw_port_getready(&siopcb_table[port]) == true) {
			sio_irdy_rcv(GET_SIOPCB(ID_PORT(port))->exinf);
		}
	}
}

/*
 *  SIOλߥϥɥ
 */
void sio_tx_handler(intptr_t exinf)
{
	int_t port;
	
	for (port=0; port<TNUM_PORT; ++port) {
		if ((siopcb_table[port].flags & SIO_STS_SENDING) != 0) {
			/* ơ */
			sil_wrb_mem((void *)(SIOCR(port)+2), 0x1);
			siopcb_table[port].flags &= ~SIO_STS_SENDING;
			sio_irdy_snd(GET_SIOPCB(ID_PORT(port))->exinf);
		}
	}
}

/*
 *  ꥢI/OݡȤؤʸ
 */
bool_t
sio_snd_chr(SIOPCB *siopcb, char_t c)
{
	if ((siopcb->flags & SIO_STS_SENDING) != 0) {
		return false;
	}
	
	switch (SIO_TYP(siopcb->flags)) {
	case SIO_TYP_M32RUART:	
		if ((sil_reb_mem((void *)(SIOSTS(siopcb->port)+3)) & 0x3) != 0) {
			siopcb->flags |= SIO_STS_SENDING;
			sil_wrb_mem((void *)(SIOTXB(siopcb->port)+3), (char_t)c);
		} 
		else {
			return false;
		}
		break;
	default:
		return false;
	}
	return true;
}

/*
 *  ꥢI/OݡȤʸ
 */
int_t
sio_rcv_chr(SIOPCB *siopcb)
{
	switch (SIO_TYP(siopcb->flags)) {
	case SIO_TYP_M32RUART:
		return sil_reb_mem((void *)(SIORXB(siopcb->port)+3));
	}
	return (-1);
}

/*
 *  ꥢI/OݡȤΥХåε
 */
void
sio_ena_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
}

/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
sio_dis_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
}
